﻿using Wisej.Web;

namespace Wisej.DataGridConditionalBinding
{
	public class MyButtonColumn : Web.DataGridViewButtonColumn
	{
		public override DataGridViewCell CellTemplate
		{
			get { return this._cellTemplate; }
			set { }
		}
		private MyButtonCell _cellTemplate = new MyButtonCell();
	}

	public class MyButtonCell : Web.DataGridViewButtonCell
	{
		protected override object GetValue()
		{
			var dataItem = (DataItem)this.OwningRow?.DataBoundItem;
			if (dataItem != null && !dataItem.CanEdit)
				return "<div style='color:red;text-align:center'>Cannot Edit</div>";

			return "Edit";
		}

		public override string CellRenderer
		{
			get
			{
				var dataItem = (DataItem)this.OwningRow?.DataBoundItem;
				if (dataItem != null && !dataItem.CanEdit)
					return "Cell";

				return base.CellRenderer;
			}
		}
	}
}