﻿
using System;
using System.Drawing;
using System.Collections.Generic;
using Wisej.Web;

namespace Wisej.DataGridConditionalBinding
{
	public partial class Page1 : Page
	{
		public Page1()
		{
			InitializeComponent();
		}

		private void Page1_Load(object sender, EventArgs e)
		{
			var data = new List<DataItem>();
			data.Add(new DataItem() {Name="Carl", LastName="White", CanEdit = true });
			data.Add(new DataItem() { Name = "Jim", LastName = "Red", CanEdit = false });
			data.Add(new DataItem() { Name = "Bill", LastName = "Smith", CanEdit = true });

			this.dataGridView1.DataSource = data;

		}

		private void dataGridView1_DataBindingComplete(object sender, DataGridViewBindingCompleteEventArgs e)
		{
			var grid = (DataGridView)sender;
			foreach (DataGridViewRow row in grid.Rows)
			{
				var dataItem = (DataItem)row.DataBoundItem;

				// change the color of the button text to show it's disabled.
				if (!dataItem.CanEdit)
				{
					row[0].Style.ForeColor = SystemColors.GrayText;
				}

				// add a button only if editing is allowed.
				if (dataItem.CanEdit)
				{
					row[1].Value = "<div role='edit' style='cursor:pointer'>Edit</div>";
				}
			}
		}

		private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
		{
			var grid = (DataGridView)sender;
			var row = grid.Rows[e.RowIndex];
			var dataItem = (DataItem)row.DataBoundItem;

			// ignore clicks not on the inner 'role' element.
			if (e.ColumnIndex == 1 && e.Role != "edit")
				return;

			if (dataItem.CanEdit)
				AlertBox.Show("You can edit me.", MessageBoxIcon.Information);
			else
				AlertBox.Show("Edit not allowed!", MessageBoxIcon.Error);

		}
	}
}
